<template>
  <div class="fr-p-2w">
    <AtomLoader
      v-if="!followUpTypeOptions || !beneficiariesCitiesOptions"
      class="fr-mx-auto"
    />
    <AtomFilters
      v-else
      :filters="statsFilters"
      @filter="onFilter"
    />
  </div>
</template>

<script setup lang="ts">
  import { useAuthStore } from '~/store/auth'
  import { FilterType } from '~/utils/constants/filters'
  import type { FilterProp } from '~/types/filter'

  const isMinistryAgent = useMinistryAgent()
  const authStore = useAuthStore()

  const emit = defineEmits<{
    (e: 'filter', filters: { [key: string]: string }): void
  }>()

  const props = defineProps<{
    followUpTypeOptions: Map<string, string>
    beneficiariesCitiesOptions: Map<string, string>
    agentOptions: Map<string, string>
    idPrefix: string
  }>()

  const statsFilters = computed(() => {
    const filters: FilterProp[] = [
      {
        name: `${props.idPrefix}-fromDate`,
        label: 'Du',
        type: FilterType.Date
      },
      {
        name: `${props.idPrefix}-toDate`,
        label: 'Au',
        type: FilterType.Date
      }
    ]
    if (props.followUpTypeOptions) {
      filters.push({
        name: `${props.idPrefix}-followUpType`,
        label: "Type d'accompagnement",
        options: props.followUpTypeOptions,
        type: FilterType.SelectMultiple
      })
    }
    if (props.beneficiariesCitiesOptions) {
      filters.push({
        name: `${props.idPrefix}-beneficiariesCities`,
        label: 'Ville',
        options: props.beneficiariesCitiesOptions,
        type: FilterType.SelectMultiple
      })
    }
    if (authStore.isResponsableDeStructure && isMinistryAgent.value) {
      filters.push({
        name: `${props.idPrefix}-referent`,
        label: 'Référent',
        options: props.agentOptions,
        type: FilterType.SelectOne
      })
    }
    return filters
  })

  function onFilter(filters: { [k: string]: string }) {
    const cleanedFilters: { [k: string]: string } = {}
    const idPrefixRegex = new RegExp(`^${props.idPrefix}-`)
    Object.entries(filters || {}).forEach(([key, value]) => {
      const keyWithoutIdPrefix = key.replace(idPrefixRegex, '')
      cleanedFilters[keyWithoutIdPrefix] = value
    })
    emit('filter', cleanedFilters)
  }
</script>
